//------------------------------------------------------------------------------
// <auto-generated>
//     This code was auto-generated by com.unity.inputsystem:InputActionCodeGenerator
//     version 1.4.4
//     from Assets/Input/InputActions.inputactions
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.InputSystem;
using UnityEngine.InputSystem.Utilities;

namespace Runtime.Input
{
    public partial class @InputActions : IInputActionCollection2, IDisposable
    {
        public InputActionAsset asset { get; }
        public @InputActions()
        {
            asset = InputActionAsset.FromJson(@"{
    ""name"": ""InputActions"",
    ""maps"": [
        {
            ""name"": ""Editor"",
            ""id"": ""636a652d-c507-487d-a81a-cabea1b0fd8b"",
            ""actions"": [
                {
                    ""name"": ""RotateRight"",
                    ""type"": ""Button"",
                    ""id"": ""51b84250-b70f-42f7-a431-cc839249d734"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""RotateLeft"",
                    ""type"": ""Button"",
                    ""id"": ""f4ccd6af-870b-4c50-be51-40881427ca06"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""MouseLeftClick"",
                    ""type"": ""Button"",
                    ""id"": ""e3ae1c88-9ea1-4ff3-b5b2-27d91882296f"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""MouseRightClick"",
                    ""type"": ""Button"",
                    ""id"": ""de50d80a-763c-4fd1-82a7-ac2caef8a846"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""MoveUp"",
                    ""type"": ""Button"",
                    ""id"": ""18f74964-0128-402e-aafe-c4cf37dca8cf"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""MoveDown"",
                    ""type"": ""Button"",
                    ""id"": ""a016d68c-51c1-4e3e-8a19-9ef7eee294be"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""Delete"",
                    ""type"": ""Button"",
                    ""id"": ""0f9cd0f2-090c-4cd3-bde7-68bc0b7d1499"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""HelpMenu"",
                    ""type"": ""Button"",
                    ""id"": ""942960af-6f70-44cc-b680-73e3304e3102"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                }
            ],
            ""bindings"": [
                {
                    ""name"": """",
                    ""id"": ""b1277c5f-7a71-4810-942c-072e89349774"",
                    ""path"": ""<Keyboard>/q"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""RotateLeft"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""fda102e0-14e9-44fa-a7e9-bf037c5b2eae"",
                    ""path"": ""<Mouse>/leftButton"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MouseLeftClick"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""3fef18fa-8490-4591-bf84-da2d1a8c1ea7"",
                    ""path"": ""<Keyboard>/e"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""RotateRight"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""3fbf73d7-9409-4efd-a0f3-90147e764c91"",
                    ""path"": ""<Keyboard>/w"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MoveUp"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""dc897569-baf8-4cc7-b252-feefed91353f"",
                    ""path"": ""<Keyboard>/s"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MoveDown"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""2acaeda3-2d52-48ba-9a27-0fb805637d79"",
                    ""path"": ""<Keyboard>/delete"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Delete"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""1118205a-21f1-4764-84fa-08211bebe29c"",
                    ""path"": ""<Mouse>/rightButton"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MouseRightClick"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""758a8746-12e2-434a-aa60-7e85097d97f5"",
                    ""path"": ""<Keyboard>/f1"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""HelpMenu"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                }
            ]
        }
    ],
    ""controlSchemes"": []
}");
            // Editor
            m_Editor = asset.FindActionMap("Editor", throwIfNotFound: true);
            m_Editor_RotateRight = m_Editor.FindAction("RotateRight", throwIfNotFound: true);
            m_Editor_RotateLeft = m_Editor.FindAction("RotateLeft", throwIfNotFound: true);
            m_Editor_MouseLeftClick = m_Editor.FindAction("MouseLeftClick", throwIfNotFound: true);
            m_Editor_MouseRightClick = m_Editor.FindAction("MouseRightClick", throwIfNotFound: true);
            m_Editor_MoveUp = m_Editor.FindAction("MoveUp", throwIfNotFound: true);
            m_Editor_MoveDown = m_Editor.FindAction("MoveDown", throwIfNotFound: true);
            m_Editor_Delete = m_Editor.FindAction("Delete", throwIfNotFound: true);
            m_Editor_HelpMenu = m_Editor.FindAction("HelpMenu", throwIfNotFound: true);
        }

        public void Dispose()
        {
            UnityEngine.Object.Destroy(asset);
        }

        public InputBinding? bindingMask
        {
            get => asset.bindingMask;
            set => asset.bindingMask = value;
        }

        public ReadOnlyArray<InputDevice>? devices
        {
            get => asset.devices;
            set => asset.devices = value;
        }

        public ReadOnlyArray<InputControlScheme> controlSchemes => asset.controlSchemes;

        public bool Contains(InputAction action)
        {
            return asset.Contains(action);
        }

        public IEnumerator<InputAction> GetEnumerator()
        {
            return asset.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public void Enable()
        {
            asset.Enable();
        }

        public void Disable()
        {
            asset.Disable();
        }
        public IEnumerable<InputBinding> bindings => asset.bindings;

        public InputAction FindAction(string actionNameOrId, bool throwIfNotFound = false)
        {
            return asset.FindAction(actionNameOrId, throwIfNotFound);
        }
        public int FindBinding(InputBinding bindingMask, out InputAction action)
        {
            return asset.FindBinding(bindingMask, out action);
        }

        // Editor
        private readonly InputActionMap m_Editor;
        private IEditorActions m_EditorActionsCallbackInterface;
        private readonly InputAction m_Editor_RotateRight;
        private readonly InputAction m_Editor_RotateLeft;
        private readonly InputAction m_Editor_MouseLeftClick;
        private readonly InputAction m_Editor_MouseRightClick;
        private readonly InputAction m_Editor_MoveUp;
        private readonly InputAction m_Editor_MoveDown;
        private readonly InputAction m_Editor_Delete;
        private readonly InputAction m_Editor_HelpMenu;
        public struct EditorActions
        {
            private @InputActions m_Wrapper;
            public EditorActions(@InputActions wrapper) { m_Wrapper = wrapper; }
            public InputAction @RotateRight => m_Wrapper.m_Editor_RotateRight;
            public InputAction @RotateLeft => m_Wrapper.m_Editor_RotateLeft;
            public InputAction @MouseLeftClick => m_Wrapper.m_Editor_MouseLeftClick;
            public InputAction @MouseRightClick => m_Wrapper.m_Editor_MouseRightClick;
            public InputAction @MoveUp => m_Wrapper.m_Editor_MoveUp;
            public InputAction @MoveDown => m_Wrapper.m_Editor_MoveDown;
            public InputAction @Delete => m_Wrapper.m_Editor_Delete;
            public InputAction @HelpMenu => m_Wrapper.m_Editor_HelpMenu;
            public InputActionMap Get() { return m_Wrapper.m_Editor; }
            public void Enable() { Get().Enable(); }
            public void Disable() { Get().Disable(); }
            public bool enabled => Get().enabled;
            public static implicit operator InputActionMap(EditorActions set) { return set.Get(); }
            public void SetCallbacks(IEditorActions instance)
            {
                if (m_Wrapper.m_EditorActionsCallbackInterface != null)
                {
                    @RotateRight.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateRight;
                    @RotateRight.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateRight;
                    @RotateRight.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateRight;
                    @RotateLeft.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateLeft;
                    @RotateLeft.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateLeft;
                    @RotateLeft.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnRotateLeft;
                    @MouseLeftClick.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseLeftClick;
                    @MouseLeftClick.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseLeftClick;
                    @MouseLeftClick.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseLeftClick;
                    @MouseRightClick.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseRightClick;
                    @MouseRightClick.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseRightClick;
                    @MouseRightClick.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnMouseRightClick;
                    @MoveUp.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveUp;
                    @MoveUp.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveUp;
                    @MoveUp.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveUp;
                    @MoveDown.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveDown;
                    @MoveDown.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveDown;
                    @MoveDown.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnMoveDown;
                    @Delete.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnDelete;
                    @Delete.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnDelete;
                    @Delete.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnDelete;
                    @HelpMenu.started -= m_Wrapper.m_EditorActionsCallbackInterface.OnHelpMenu;
                    @HelpMenu.performed -= m_Wrapper.m_EditorActionsCallbackInterface.OnHelpMenu;
                    @HelpMenu.canceled -= m_Wrapper.m_EditorActionsCallbackInterface.OnHelpMenu;
                }
                m_Wrapper.m_EditorActionsCallbackInterface = instance;
                if (instance != null)
                {
                    @RotateRight.started += instance.OnRotateRight;
                    @RotateRight.performed += instance.OnRotateRight;
                    @RotateRight.canceled += instance.OnRotateRight;
                    @RotateLeft.started += instance.OnRotateLeft;
                    @RotateLeft.performed += instance.OnRotateLeft;
                    @RotateLeft.canceled += instance.OnRotateLeft;
                    @MouseLeftClick.started += instance.OnMouseLeftClick;
                    @MouseLeftClick.performed += instance.OnMouseLeftClick;
                    @MouseLeftClick.canceled += instance.OnMouseLeftClick;
                    @MouseRightClick.started += instance.OnMouseRightClick;
                    @MouseRightClick.performed += instance.OnMouseRightClick;
                    @MouseRightClick.canceled += instance.OnMouseRightClick;
                    @MoveUp.started += instance.OnMoveUp;
                    @MoveUp.performed += instance.OnMoveUp;
                    @MoveUp.canceled += instance.OnMoveUp;
                    @MoveDown.started += instance.OnMoveDown;
                    @MoveDown.performed += instance.OnMoveDown;
                    @MoveDown.canceled += instance.OnMoveDown;
                    @Delete.started += instance.OnDelete;
                    @Delete.performed += instance.OnDelete;
                    @Delete.canceled += instance.OnDelete;
                    @HelpMenu.started += instance.OnHelpMenu;
                    @HelpMenu.performed += instance.OnHelpMenu;
                    @HelpMenu.canceled += instance.OnHelpMenu;
                }
            }
        }
        public EditorActions @Editor => new EditorActions(this);
        public interface IEditorActions
        {
            void OnRotateRight(InputAction.CallbackContext context);
            void OnRotateLeft(InputAction.CallbackContext context);
            void OnMouseLeftClick(InputAction.CallbackContext context);
            void OnMouseRightClick(InputAction.CallbackContext context);
            void OnMoveUp(InputAction.CallbackContext context);
            void OnMoveDown(InputAction.CallbackContext context);
            void OnDelete(InputAction.CallbackContext context);
            void OnHelpMenu(InputAction.CallbackContext context);
        }
    }
}
